///
/// \author	John Farrier
///
/// \copyright Copyright 2014 John Farrier 
///
/// Licensed under the Apache License, Version 2.0 (the "License");
/// you may not use this file except in compliance with the License.
/// You may obtain a copy of the License at
/// 
/// http://www.apache.org/licenses/LICENSE-2.0
/// 
/// Unless required by applicable law or agreed to in writing, software
/// distributed under the License is distributed on an "AS IS" BASIS,
/// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
/// See the License for the specific language governing permissions and
/// limitations under the License.
///

#include <celero/TestFixture.h>

#include <iostream>
#include <algorithm>

#include <assert.h>

using namespace celero;

TestFixture::TestFixture()
{
}

TestFixture::~TestFixture()
{
}

void TestFixture::setUp(int64_t)
{
}

void TestFixture::tearDown()
{
}
	
uint64_t TestFixture::run(const uint64_t calls, int64_t experimentValue)
{
	// Set up the testing fixture.
	this->setUp(experimentValue);

	// Run the test body for each operation.
	auto operation = calls;
			
	// Get the starting time.
	const auto startTime = celero::timer::GetSystemTime();
			
	while(operation--)
	{
		this->UserBenchmark();
	}
			
	const auto endTime = celero::timer::GetSystemTime();

	// Tear down the testing fixture.
	this->tearDown();
			
	// Return the duration in microseconds for the given problem size.
	return (endTime - startTime);
}

void TestFixture::UserBenchmark()
{
}
